const { get } = require('node-superfetch');
const chalk = require('chalk');
const { version } = require('../../package.json');

/**
* @class NSFW
*/
class NSFW {
	constructor(token, baseURL) {
		/**
         * Your Lunar API Token.
         * @type {string}
         * @private
        */
		this.token = token;

		/**
          * The base URL.
          * @type {string}
          * @private
         */
		this.baseURL = baseURL;
	}

	/**
      * Returns a random GIF under the 'ahegao' endpoint.
	  * @param {boolean} json - Whether to return the Image ID instead of the image URL.
      * @returns {Promise<string>} The raw JSON response if json is true
      */
	async ahegao(json) {
		try {
			const { body } = await get(`${this.baseURL}/ahegao`)
				.set('Authorization', `Bearer ${this.token}`)
				.set('User-Agent', `LunarAPI » v${version}`);
			if (json) {
				return body;
			}
			else {
				return body.url;
			}
		}
		catch (e) {
			throw new Error(`${chalk.magenta('LunarAPI')} ${chalk.gray('»')} ${chalk.red(`An unknown error has occured!:\n\n${e}`)}`);
		}
	}

	/**
      * Returns a random GIF under the 'ass' endpoint.
	  * @param {boolean} json - Whether to return the Image ID instead of the image URL.
      * @returns {Promise<string>} The raw JSON response if json is true
      */
	async ass(json) {
		try {
			const { body } = await get(`${this.baseURL}/ass`)
				.set('Authorization', `Bearer ${this.token}`)
				.set('User-Agent', `LunarAPI » v${version}`);
			if (json) {
				return body;
			}
			else {
				return body.url;
			}
		}
		catch (e) {
			throw new Error(`${chalk.magenta('LunarAPI')} ${chalk.gray('»')} ${chalk.red(`An unknown error has occured!:\n\n${e}`)}`);
		}
	}

	/**
      * Returns a random GIF under the 'cum' endpoint.
	  * @param {boolean} json - Whether to return the Image ID instead of the image URL.
      * @returns {Promise<string>} The raw JSON response if json is true
      */
	async cum(json) {
		try {
			const { body } = await get(`${this.baseURL}/cum`)
				.set('Authorization', `Bearer ${this.token}`)
				.set('User-Agent', `LunarAPI » v${version}`);
			if (json) {
				return body;
			}
			else {
				return body.url;
			}
		}
		catch (e) {
			throw new Error(`${chalk.magenta('LunarAPI')} ${chalk.gray('»')} ${chalk.red(`An unknown error has occured!:\n\n${e}`)}`);
		}
	}

	/**
      * Returns a random GIF under the 'boobs' endpoint.
	  * @param {boolean} json - Whether to return the Image ID instead of the image URL.
      * @returns {Promise<string>} The raw JSON response if json is true
      */
	async boobs(json) {
		try {
			const { body } = await get(`${this.baseURL}/boobs`)
				.set('Authorization', `Bearer ${this.token}`)
				.set('User-Agent', `LunarAPI » v${version}`);
			if (json) {
				return body;
			}
			else {
				return body.url;
			}
		}
		catch (e) {
			throw new Error(`${chalk.magenta('LunarAPI')} ${chalk.gray('»')} ${chalk.red(`An unknown error has occured!:\n\n${e}`)}`);
		}
	}

	/**
      * Returns a random GIF under the 'gif' endpoint.
	  * @param {boolean} json - Whether to return the Image ID instead of the image URL.
      * @returns {Promise<string>} The raw JSON response if json is true
      */
	async gif(json) {
		try {
			const { body } = await get(`${this.baseURL}/gif`)
				.set('Authorization', `Bearer ${this.token}`)
				.set('User-Agent', `LunarAPI » v${version}`);
			if (json) {
				return body;
			}
			else {
				return body.url;
			}
		}
		catch (e) {
			throw new Error(`${chalk.magenta('LunarAPI')} ${chalk.gray('»')} ${chalk.red(`An unknown error has occured!:\n\n${e}`)}`);
		}
	}

	/**
      * Returns a random GIF under the 'hololive' endpoint.
	  * @param {boolean} json - Whether to return the Image ID instead of the image URL.
      * @returns {Promise<string>} The raw JSON response if json is true
      */
	async hololive(json) {
		try {
			const { body } = await get(`${this.baseURL}/hololive`)
				.set('Authorization', `Bearer ${this.token}`)
				.set('User-Agent', `LunarAPI » v${version}`);
			if (json) {
				return body;
			}
			else {
				return body.url;
			}
		}
		catch (e) {
			throw new Error(`${chalk.magenta('LunarAPI')} ${chalk.gray('»')} ${chalk.red(`An unknown error has occured!:\n\n${e}`)}`);
		}
	}

	/**
      * Returns a random GIF under the 'jpg' endpoint.
	  * @param {boolean} json - Whether to return the Image ID instead of the image URL.
      * @returns {Promise<string>} The raw JSON response if json is true
      */
	async jpg(json) {
		try {
			const { body } = await get(`${this.baseURL}/jpg`)
				.set('Authorization', `Bearer ${this.token}`)
				.set('User-Agent', `LunarAPI » v${version}`);
			if (json) {
				return body;
			}
			else {
				return body.url;
			}
		}
		catch (e) {
			throw new Error(`${chalk.magenta('LunarAPI')} ${chalk.gray('»')} ${chalk.red(`An unknown error has occured!:\n\n${e}`)}`);
		}
	}

	/**
      * Returns a random GIF under the 'neko' endpoint.
	  * @param {boolean} json - Whether to return the Image ID instead of the image URL.
      * @returns {Promise<string>} The raw JSON response if json is true
      */
	async neko(json) {
		try {
			const { body } = await get(`${this.baseURL}/neko`)
				.set('Authorization', `Bearer ${this.token}`)
				.set('User-Agent', `LunarAPI » v${version}`);
			if (json) {
				return body;
			}
			else {
				return body.url;
			}
		}
		catch (e) {
			throw new Error(`${chalk.magenta('LunarAPI')} ${chalk.gray('»')} ${chalk.red(`An unknown error has occured!:\n\n${e}`)}`);
		}
	}

	/**
      * Returns a random GIF under the 'panties' endpoint.
	  * @param {boolean} json - Whether to return the Image ID instead of the image URL.
      * @returns {Promise<string>} The raw JSON response if json is true
      */
	async panties(json) {
		try {
			const { body } = await get(`${this.baseURL}/panties`)
				.set('Authorization', `Bearer ${this.token}`)
				.set('User-Agent', `LunarAPI » v${version}`);
			if (json) {
				return body;
			}
			else {
				return body.url;
			}
		}
		catch (e) {
			throw new Error(`${chalk.magenta('LunarAPI')} ${chalk.gray('»')} ${chalk.red(`An unknown error has occured!:\n\n${e}`)}`);
		}
	}

	/**
      * Returns a random GIF under the 'thighs' endpoint.
	  * @param {boolean} json - Whether to return the Image ID instead of the image URL.
      * @returns {Promise<string>} The raw JSON response if json is true
      */
	async thighs(json) {
		try {
			const { body } = await get(`${this.baseURL}/thighs`)
				.set('Authorization', `Bearer ${this.token}`)
				.set('User-Agent', `LunarAPI » v${version}`);
			if (json) {
				return body;
			}
			else {
				return body.url;
			}
		}
		catch (e) {
			throw new Error(`${chalk.magenta('LunarAPI')} ${chalk.gray('»')} ${chalk.red(`An unknown error has occured!:\n\n${e}`)}`);
		}
	}

	/**
      * Returns a random GIF under the 'yuri' endpoint.
	  * @param {boolean} json - Whether to return the Image ID instead of the image URL.
      * @returns {Promise<string>} The raw JSON response if json is true
      */
	async yuri(json) {
		try {
			const { body } = await get(`${this.baseURL}/yuri`)
				.set('Authorization', `Bearer ${this.token}`)
				.set('User-Agent', `LunarAPI » v${version}`);
			if (json) {
				return body;
			}
			else {
				return body.url;
			}
		}
		catch (e) {
			throw new Error(`${chalk.magenta('LunarAPI')} ${chalk.gray('»')} ${chalk.red(`An unknown error has occured!:\n\n${e}`)}`);
		}
	}
}

module.exports = NSFW;