# ⚡ Lunar API

<center>
    <h3>
        <kbd>JS Library for the Lunar API
    </h3>
</center>

---

### Lunar API lets you interact with our image libraries and image generation
<br>

> Currently this library does not support our image generation endpoints, but will be available in a later update.

```js
require('dotenv').config();
const LunarAPI = require('lunar-api');
const lunar = new LunarAPI(process.env.LUNARAPI); // Your API Key goes here

(async () => {
	const res = await lunar.sfw.hug();
	// const resid = await lunar.sfw.hug(true); 
    // Passing true returns the raw JSON response with the ID and URL
    
	console.log(res);
    /* If passing true to return the JSON response, simply do the following to get each key/value:
    console.log(res.id) or console.log(res.url)
    */
})();
```

# **Lunar API Docs:**
## https://docs.lunardev.group
